Index: mariadb-10.11.11/mysql-test/suite/innodb/r/restart.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/restart.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/restart.result
@@ -30,19 +30,6 @@ SELECT * FROM td;
 a
 DROP TABLE tr,tc,td;
 #
-# MDEV-27467 innodb to enfore the minimum innodb_buffer_pool_size in SET (resize) the same as startup
-#
-SELECT @@innodb_buffer_pool_size INTO @innodb_buffer_pool_size_orig;
-SELECT CEILING((256 + 64) * @@innodb_page_size / 1048576) * 1048576 INTO @min_pool_size;
-EXECUTE IMMEDIATE 'SET GLOBAL innodb_buffer_pool_size = ?' USING (@min_pool_size -1);
-ERROR 42000: Variable 'innodb_buffer_pool_size' can't be set to the value of 'WRONG_VALUE'
-SHOW WARNINGS;
-Level	Code	Message
-Warning	1210	innodb_buffer_pool_size must be at least MIN_VAL for innodb_page_size=PAGE_SIZE
-Error	1231	Variable 'innodb_buffer_pool_size' can't be set to the value of 'WRONG_VALUE'
-EXECUTE IMMEDIATE 'SET GLOBAL innodb_buffer_pool_size = ?' USING (@min_pool_size);
-SET GLOBAL innodb_buffer_pool_size = @innodb_buffer_pool_size_orig;
-#
 # MDEV-27882 Innodb - recognise MySQL-8.0 innodb flags and give a specific error message
 #
 FOUND 1 /InnoDB: MySQL-8\.0 tablespace in \./ibdata1/ in attempted_start.err
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb-index-online.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb-index-online.opt
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb-index-online.opt
@@ -1,5 +1,5 @@
 --loose-innodb-sort-buffer-size=64k
 --loose-innodb-online-alter-log-max-size=128k
---loose-innodb-buffer-pool-size=5M
+--loose-innodb-buffer-pool-size=6M
 --loose-innodb-sys-indexes
 --loose-innodb-sys-fields
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb-table-online-master.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb-table-online-master.opt
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb-table-online-master.opt
@@ -1 +1 @@
---innodb-sort-buffer-size=64k --innodb-online-alter-log-max-size=512k --innodb-buffer-pool-size=5M
+--innodb-sort-buffer-size=64k --innodb-online-alter-log-max-size=512k --innodb-buffer-pool-size=6M
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_fail.opt
===================================================================
--- /dev/null
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_fail.opt
@@ -0,0 +1 @@
+--innodb-buffer-pool-size-max=16m
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_fail.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb_buffer_pool_fail.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_fail.test
@@ -1,6 +1,6 @@
 --source include/have_innodb.inc
 --source include/have_debug.inc
-call mtr.add_suppression("InnoDB: Cannot allocate memory for the buffer pool");
+call mtr.add_suppression("InnoDB: Cannot map innodb_buffer_pool_size_max=");
 call mtr.add_suppression("InnoDB: Plugin initialization aborted at srv0start.cc.*");
 call mtr.add_suppression("Plugin 'InnoDB' init function returned error.");
 call mtr.add_suppression("Plugin 'InnoDB' registration as a STORAGE ENGINE failed.");
@@ -10,5 +10,5 @@ call mtr.add_suppression("Plugin 'InnoDB
 let restart_parameters=--debug_dbug=+d,ib_buf_chunk_init_fails;
 --source include/restart_mysqld.inc
 let SEARCH_FILE = $MYSQLTEST_VARDIR/log/mysqld.1.err;
-let SEARCH_PATTERN=\[ERROR\] InnoDB: Cannot allocate memory for the buffer pool;
+let SEARCH_PATTERN=\[ERROR\] InnoDB: Cannot map innodb_buffer_pool_size_max=16m;
 --source include/search_pattern_in_file.inc
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.opt
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.opt
@@ -1,2 +1,3 @@
 --innodb-buffer-pool-size=8M
+--innodb-buffer-pool-size-max=24M
 --innodb-page-size=4k
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize.test
@@ -1,17 +1,13 @@
-#
-# WL6117 : Resize the InnoDB Buffer Pool Online
-#
-
 --source include/have_innodb.inc
---source include/big_test.inc
+--source include/have_sequence.inc
 
-let $wait_timeout = 180;
-let $wait_condition =
-  SELECT SUBSTR(variable_value, 1, 30) = 'Completed resizing buffer pool'
-  FROM information_schema.global_status
-  WHERE LOWER(variable_name) = 'innodb_buffer_pool_resize_status';
+--echo #
+--echo # MDEV-29445: Reorganize buffer pool (and remove chunks)
+--echo #
 
 --disable_query_log
+call mtr.add_suppression("InnoDB: Over 67 percent of the buffer pool is occupied by lock heaps");
+call mtr.add_suppression("innodb_buffer_pool_size change aborted");
 set @old_innodb_buffer_pool_size = @@innodb_buffer_pool_size;
 set @old_innodb_adaptive_hash_index = @@innodb_adaptive_hash_index;
 --enable_query_log
@@ -21,10 +17,9 @@ set global innodb_adaptive_hash_index=ON
 select @@innodb_buffer_pool_size;
 
 # Expand buffer pool
+set global innodb_buffer_pool_size = 9437184;
 set global innodb_buffer_pool_size = 10485760;
 
---source include/wait_condition.inc
-
 select @@innodb_buffer_pool_size;
 
 # fill buffer pool
@@ -32,41 +27,48 @@ select @@innodb_buffer_pool_size;
 SET @save_innodb_read_only_compressed=@@GLOBAL.innodb_read_only_compressed;
 SET GLOBAL innodb_read_only_compressed=OFF;
 --enable_query_log
-create table t1 (id int not null, val int not null default '0', primary key (id)) ENGINE=InnoDB ROW_FORMAT=COMPRESSED;
-create or replace view view0 as select 1 union all select 1;
+create table t1 (id int primary key, val int not null)
+ENGINE=InnoDB ROW_FORMAT=COMPRESSED;
 
-set @`v_id` := 0;
-set @`v_val` := 0;
+SET STATEMENT foreign_key_checks=0, unique_checks=0 FOR
+INSERT INTO t1 SELECT seq*4,seq*4 FROM seq_1_to_262144;
 
-# 2^18 == 262144 records
-replace into t1 select (@`v_id` := (@`v_id` + 4) mod 4294967296) as id, (@`v_val` := (@`v_val` + 4) mod 4294967296) as val from view0 v0, view0 v1, view0 v2, view0 v3, view0 v4, view0 v5, view0 v6, view0 v7, view0 v8, view0 v9, view0 v10, view0 v11, view0 v12, view0 v13, view0 v14, view0 v15, view0 v16, view0 v17;
 --disable_query_log
 SET GLOBAL innodb_read_only_compressed=@save_innodb_read_only_compressed;
 --enable_query_log
 
-# Shrink buffer pool
-set global innodb_buffer_pool_size = 64 * 1024 * 1024 + 512 * 1024;
---source include/wait_condition.inc
-
-select @@innodb_buffer_pool_size;
+# Attempt to shrink the buffer pool. This may occasionally fail.
+--error 0,ER_WRONG_USAGE
+set global innodb_buffer_pool_size = 7340032;
 
 select count(val) from t1;
 
 set global innodb_adaptive_hash_index=OFF;
 
-# Expand buffer pool to 24MB
-set global innodb_buffer_pool_size = 25165824;
---source include/wait_condition.inc
+# Expand buffer pool to 23 and then 24 MiB (requesting 25 MiB)
+set global innodb_buffer_pool_size = 24117248;
+set global innodb_buffer_pool_size = 26214400;
 
 select @@innodb_buffer_pool_size;
 
 select count(val) from t1;
 
 drop table t1;
-drop view view0;
 
---disable_query_log
-set global innodb_adaptive_hash_index = @old_innodb_adaptive_hash_index;
-set global innodb_buffer_pool_size = @old_innodb_buffer_pool_size;
---enable_query_log
+SET GLOBAL innodb_max_purge_lag_wait = 0;
+SET @save_pct= @@GLOBAL.innodb_max_dirty_pages_pct;
+SET @save_pct_lwm= @@GLOBAL.innodb_max_dirty_pages_pct_lwm;
+
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = 0.0;
+SET GLOBAL innodb_max_dirty_pages_pct = 0.0;
+let $wait_condition =
+SELECT variable_value = 0
+FROM information_schema.global_status
+WHERE variable_name = 'INNODB_BUFFER_POOL_PAGES_DIRTY';
 --source include/wait_condition.inc
+# this may occasionally be aborted on a heavily loaded builder
+--error 0,ER_WRONG_USAGE
+SET GLOBAL innodb_buffer_pool_size = @old_innodb_buffer_pool_size;
+SET GLOBAL innodb_adaptive_hash_index = @old_innodb_adaptive_hash_index;
+SET GLOBAL innodb_max_dirty_pages_pct = @save_pct;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = @save_pct_lwm;
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.opt
===================================================================
--- /dev/null
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.opt
@@ -0,0 +1 @@
+--innodb-buffer-pool-size-max=16m
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.test
@@ -1,24 +1,43 @@
 --source include/have_innodb.inc
 --source include/have_sequence.inc
 --source include/have_debug.inc
+--source include/have_debug_sync.inc
 
 SET @save_limit=@@GLOBAL.innodb_limit_optimistic_insert_debug;
 SET @save_size=@@GLOBAL.innodb_buffer_pool_size;
 SET GLOBAL innodb_limit_optimistic_insert_debug=2;
-
 SET GLOBAL innodb_buffer_pool_size=16777216;
 
 CREATE TEMPORARY TABLE t1 (a INT PRIMARY KEY) ENGINE=InnoDB;
 INSERT INTO t1 SELECT seq FROM seq_1_to_200;
 
-SET GLOBAL innodb_buffer_pool_size=8388608;
+# Flush the buffer pool to prevent
+# "innodb_buffer_pool_size change aborted" error with ./mtr --repeat=3
+SET GLOBAL innodb_max_purge_lag_wait=0;
+SET @save_pct= @@GLOBAL.innodb_max_dirty_pages_pct;
+SET @save_pct_lwm= @@GLOBAL.innodb_max_dirty_pages_pct_lwm;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = 0.0;
+SET GLOBAL innodb_max_dirty_pages_pct = 0.0;
+
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+connect con1,localhost,root;
+SET DEBUG_SYNC='buf_pool_shrink_before_wakeup SIGNAL blocked WAIT_FOR go';
+send SET GLOBAL innodb_buffer_pool_size=8388608;
+connection default;
+SET DEBUG_SYNC='now WAIT_FOR blocked';
+# adjust for 32-bit
+--replace_result 504/504 505/505
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+SET DEBUG_SYNC='now SIGNAL go';
+connection con1;
+reap;
+disconnect con1;
+connection default;
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+SET DEBUG_SYNC=RESET;
 
-let $wait_timeout = 60;
-let $wait_condition =
-  SELECT SUBSTR(variable_value, 1, 30) = 'Completed resizing buffer pool'
-  FROM information_schema.global_status
-  WHERE variable_name = 'INNODB_BUFFER_POOL_RESIZE_STATUS';
---source include/wait_condition.inc
+SET GLOBAL innodb_max_dirty_pages_pct = @save_pct;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = @save_pct_lwm;
 
 SELECT COUNT(*),MIN(a),MAX(a) FROM t1;
 DROP TEMPORARY TABLE t1;
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/lock_memory_debug.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/lock_memory_debug.opt
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/lock_memory_debug.opt
@@ -1 +1 @@
---innodb_buffer_pool_size=5M
+--innodb_buffer_pool_size=6M
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/lock_memory_debug.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/lock_memory_debug.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/lock_memory_debug.test
@@ -15,7 +15,7 @@ INSERT INTO t1 VALUES (1),(2),(3),(4),(5
 
 --error ER_LOCK_TABLE_FULL
 SET STATEMENT debug_dbug='+d,innodb_skip_lock_bitmap' FOR
-INSERT INTO t1 SELECT a.* FROM t1 a, t1 b, t1 c, t1 d, t1 e, t1 f, t1 g LIMIT 45000;
+INSERT INTO t1 SELECT a.* FROM t1 a, t1 b, t1 c, t1 d, t1 e, t1 f, t1 g;
 
 SELECT COUNT(*) FROM t1;
 
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/log_upgrade_101_flags.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/log_upgrade_101_flags.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/log_upgrade_101_flags.test
@@ -73,7 +73,7 @@ print OUT chr(0);
 close OUT or die;
 EOF
 
---let $restart_parameters= $dirs --innodb-force-recovery=5 --innodb-log-file-size=4m --innodb_page_size=32k --innodb_buffer_pool_size=10M
+--let $restart_parameters= $dirs --innodb-force-recovery=5 --innodb-log-file-size=4m --innodb_page_size=32k --innodb_buffer_pool_size=11M
 --source include/start_mysqld.inc
 SELECT COUNT(*) FROM INFORMATION_SCHEMA.ENGINES
 WHERE engine = 'innodb'
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/mem_pressure.opt
===================================================================
--- /dev/null
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/mem_pressure.opt
@@ -0,0 +1,2 @@
+--innodb-buffer-pool-size-max=17m
+--innodb-buffer-pool-size=17m
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/mem_pressure.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/mem_pressure.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/mem_pressure.test
@@ -1,5 +1,4 @@
 --source include/have_debug.inc
---source include/have_cgroupv2.inc
 --source include/not_embedded.inc
 --source include/have_innodb.inc
 --source include/have_sequence.inc
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/purge_secondary.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/purge_secondary.opt
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/purge_secondary.opt
@@ -1,4 +1,4 @@
 --innodb-sys-tablestats
---innodb_buffer_pool_size=5M
+--innodb_buffer_pool_size=6M
 --innodb_monitor_enable=module_buffer
 --skip-innodb-stats-persistent
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/recovery_memory.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/recovery_memory.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/recovery_memory.test
@@ -22,7 +22,7 @@ send CALL dorepeat();
 connection default;
 sleep 10;
 let $shutdown_timeout=0;
-let $restart_parameters=--innodb_buffer_pool_size=5242880;
+let $restart_parameters=--innodb_buffer_pool_size=6m;
 --source include/restart_mysqld.inc
 DROP TABLE t1;
 DROP PROCEDURE dorepeat;
@@ -33,11 +33,11 @@ DROP PROCEDURE dorepeat;
 --echo #
 if ($have_debug) {
 SET DEBUG_DBUG="+d,ib_log_checkpoint_avoid_hard";
-let $restart_parameters=--innodb_buffer_pool_size=5242880 --debug_dbug=+d,ibuf_init_corrupt;
+let $restart_parameters=--innodb_buffer_pool_size=6m --debug_dbug=+d,ibuf_init_corrupt;
 }
 if (!$have_debug) {
 --echo SET DEBUG_DBUG="+d,ib_log_checkpoint_avoid_hard";
-let $restart_parameters=--innodb_buffer_pool_size=5242880;
+let $restart_parameters=--innodb_buffer_pool_size=6m;
 }
 CREATE TABLE t1(f1 INT NOT NULL)ENGINE=InnoDB;
 INSERT INTO t1 SELECT * FROM seq_1_to_65536;
Index: mariadb-10.11.11/mysql-test/suite/innodb/t/restart.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/t/restart.test
+++ mariadb-10.11.11/mysql-test/suite/innodb/t/restart.test
@@ -93,31 +93,6 @@ SELECT * FROM td;
 DROP TABLE tr,tc,td;
 
 --echo #
---echo # MDEV-27467 innodb to enfore the minimum innodb_buffer_pool_size in SET (resize) the same as startup
---echo #
-
-let $wait_timeout = 180;
-let $wait_condition =
-  SELECT SUBSTR(variable_value, 1, 30) = 'Completed resizing buffer pool'
-  FROM information_schema.global_status
-  WHERE LOWER(variable_name) = 'innodb_buffer_pool_resize_status';
-
---disable_cursor_protocol
-SELECT @@innodb_buffer_pool_size INTO @innodb_buffer_pool_size_orig;
-SELECT CEILING((256 + 64) * @@innodb_page_size / 1048576) * 1048576 INTO @min_pool_size;
---enable_cursor_protocol
---error ER_WRONG_VALUE_FOR_VAR
-EXECUTE IMMEDIATE 'SET GLOBAL innodb_buffer_pool_size = ?' USING (@min_pool_size -1);
-
-SHOW WARNINGS;
-
-EXECUTE IMMEDIATE 'SET GLOBAL innodb_buffer_pool_size = ?' USING (@min_pool_size);
-
---source include/wait_condition.inc
-
-SET GLOBAL innodb_buffer_pool_size = @innodb_buffer_pool_size_orig;
-
---echo #
 --echo # MDEV-27882 Innodb - recognise MySQL-8.0 innodb flags and give a specific error message
 --echo #
 
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/r/innodb_buffer_pool_size_basic.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/sys_vars/r/innodb_buffer_pool_size_basic.result
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/r/innodb_buffer_pool_size_basic.result
@@ -1,16 +1,17 @@
 SET @start_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size;
-'#---------------------BS_STVARS_022_01----------------------#'
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
-COUNT(@@GLOBAL.innodb_buffer_pool_size)
-1
-1 Expected
 '#---------------------BS_STVARS_022_02----------------------#'
-SET @@GLOBAL.innodb_buffer_pool_size=10485760;
-Expected succeeded
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
-COUNT(@@GLOBAL.innodb_buffer_pool_size)
+SELECT @@GLOBAL.innodb_buffer_pool_size_max;
+@@GLOBAL.innodb_buffer_pool_size_max
+8388608
+SELECT @@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max;
+@@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max
+1
+SET GLOBAL innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max + 1048576;
+Warnings:
+Warning	1292	Truncated incorrect innodb_buffer_pool_size value: '9437184'
+SELECT @@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max;
+@@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max
 1
-1 Expected
 '#---------------------BS_STVARS_022_03----------------------#'
 SELECT @@GLOBAL.innodb_buffer_pool_size = VARIABLE_VALUE
 FROM INFORMATION_SCHEMA.GLOBAL_VARIABLES
@@ -18,10 +19,6 @@ WHERE VARIABLE_NAME='innodb_buffer_pool_
 @@GLOBAL.innodb_buffer_pool_size = VARIABLE_VALUE
 1
 1 Expected
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
-COUNT(@@GLOBAL.innodb_buffer_pool_size)
-1
-1 Expected
 SELECT COUNT(VARIABLE_VALUE)
 FROM INFORMATION_SCHEMA.GLOBAL_VARIABLES 
 WHERE VARIABLE_NAME='innodb_buffer_pool_size';
@@ -50,4 +47,7 @@ COUNT(@@GLOBAL.innodb_buffer_pool_size)
 1 Expected
 SELECT innodb_buffer_pool_size = @@SESSION.innodb_buffer_pool_size;
 ERROR 42S22: Unknown column 'innodb_buffer_pool_size' in 'SELECT'
-# restart
+SET GLOBAL innodb_buffer_pool_size = @start_buffer_pool_size;
+SELECT @@innodb_buffer_pool_size = @start_buffer_pool_size;
+@@innodb_buffer_pool_size = @start_buffer_pool_size
+1
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/r/sysvars_innodb,32bit.rdiff
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/sys_vars/r/sysvars_innodb,32bit.rdiff
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/r/sysvars_innodb,32bit.rdiff
@@ -24,7 +24,7 @@
  VARIABLE_SCOPE	GLOBAL
 -VARIABLE_TYPE	BIGINT UNSIGNED
 +VARIABLE_TYPE	INT UNSIGNED
- VARIABLE_COMMENT	Size of a single memory chunk for resizing buffer pool. Online buffer pool resizing happens at this granularity. 0 means autosize this variable based on buffer pool size.
+ VARIABLE_COMMENT	Deprecated parameter with no effect
  NUMERIC_MIN_VALUE	0
 -NUMERIC_MAX_VALUE	18446744073709551615
 +NUMERIC_MAX_VALUE	4294967295
@@ -40,7 +40,35 @@
  VARIABLE_COMMENT	Dump only the hottest N% of each buffer pool, defaults to 25
  NUMERIC_MIN_VALUE	1
  NUMERIC_MAX_VALUE	100
-@@ -203,7 +203,7 @@
+@@ -203,10 +203,10 @@
+ SESSION_VALUE	NULL
+ DEFAULT_VALUE	134217728
+ VARIABLE_SCOPE	GLOBAL
+-VARIABLE_TYPE	BIGINT UNSIGNED
++VARIABLE_TYPE	INT UNSIGNED
+ VARIABLE_COMMENT	The size of the memory buffer InnoDB uses to cache data and indexes of its tables.
+ NUMERIC_MIN_VALUE	2097152
+-NUMERIC_MAX_VALUE	18446744073701163008
++NUMERIC_MAX_VALUE	4292870144
+ NUMERIC_BLOCK_SIZE	1048576
+ ENUM_VALUE_LIST	NULL
+ READ_ONLY	NO
+@@ -215,11 +215,11 @@
+ SESSION_VALUE	NULL
+ DEFAULT_VALUE	0
+ VARIABLE_SCOPE	GLOBAL
+-VARIABLE_TYPE	BIGINT UNSIGNED
++VARIABLE_TYPE	INT UNSIGNED
+ VARIABLE_COMMENT	Maximum innodb_buffer_pool_size
+ NUMERIC_MIN_VALUE	0
+-NUMERIC_MAX_VALUE	18446744073701163008
+-NUMERIC_BLOCK_SIZE	8388608
++NUMERIC_MAX_VALUE	4292870144
++NUMERIC_BLOCK_SIZE	2097152
+ ENUM_VALUE_LIST	NULL
+ READ_ONLY	YES
+ COMMAND_LINE_ARGUMENT	REQUIRED
+@@ -227,7 +227,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	0
  VARIABLE_SCOPE	GLOBAL
@@ -49,7 +77,7 @@
  VARIABLE_COMMENT	A number between [0, 100] that tells how oftern buffer pool dump status in percentages should be printed. E.g. 10 means that buffer pool dump status is printed when every 10% of number of buffer pool pages are dumped. Default is 0 (only start and end status is printed).
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	100
-@@ -323,7 +323,7 @@
+@@ -347,7 +347,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	5
  VARIABLE_SCOPE	GLOBAL
@@ -58,7 +86,7 @@
  VARIABLE_COMMENT	If the compression failure rate of a table is greater than this number more padding is added to the pages to reduce the failures. A value of zero implies no padding
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	100
-@@ -347,7 +347,7 @@
+@@ -371,7 +371,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	50
  VARIABLE_SCOPE	GLOBAL
@@ -67,7 +95,7 @@
  VARIABLE_COMMENT	Percentage of empty space on a data page that can be reserved to make the page compressible.
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	75
-@@ -623,7 +623,7 @@
+@@ -659,7 +659,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	600
  VARIABLE_SCOPE	GLOBAL
@@ -76,7 +104,7 @@
  VARIABLE_COMMENT	Maximum number of seconds that semaphore times out in InnoDB.
  NUMERIC_MIN_VALUE	1
  NUMERIC_MAX_VALUE	4294967295
-@@ -671,7 +671,7 @@
+@@ -707,7 +707,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	30
  VARIABLE_SCOPE	GLOBAL
@@ -85,7 +113,7 @@
  VARIABLE_COMMENT	Number of iterations over which the background flushing is averaged.
  NUMERIC_MIN_VALUE	1
  NUMERIC_MAX_VALUE	1000
-@@ -695,7 +695,7 @@
+@@ -731,7 +731,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	1
  VARIABLE_SCOPE	GLOBAL
@@ -94,7 +122,7 @@
  VARIABLE_COMMENT	Controls the durability/speed trade-off for commits. Set to 0 (write and flush redo log to disk only once per second), 1 (flush to disk at each commit), 2 (write to log at commit but flush to disk only once per second) or 3 (flush to disk at prepare and at commit, slower and usually redundant). 1 and 3 guarantees that after a crash, committed transactions will not be lost and will be consistent with the binlog and other transactional engines. 2 can get inconsistent and lose transactions if there is a power failure or kernel crash but not if mysqld crashes. 0 has no guarantees in case of crash. 0 and 2 can be faster than 1 or 3.
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	3
-@@ -719,7 +719,7 @@
+@@ -755,7 +755,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	1
  VARIABLE_SCOPE	GLOBAL
@@ -103,7 +131,7 @@
  VARIABLE_COMMENT	Set to 0 (don't flush neighbors from buffer pool), 1 (flush contiguous neighbors from buffer pool) or 2 (flush neighbors from buffer pool), when flushing a block
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	2
-@@ -755,7 +755,7 @@
+@@ -791,7 +791,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	0
  VARIABLE_SCOPE	GLOBAL
@@ -112,7 +140,7 @@
  VARIABLE_COMMENT	Helps to save your data in case the disk image of the database becomes corrupt. Value 5 can return bogus data, and 6 can permanently corrupt data.
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	6
-@@ -779,10 +779,10 @@
+@@ -815,10 +815,10 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	8000000
  VARIABLE_SCOPE	GLOBAL
@@ -125,7 +153,7 @@
  NUMERIC_BLOCK_SIZE	0
  ENUM_VALUE_LIST	NULL
  READ_ONLY	NO
-@@ -815,7 +815,7 @@
+@@ -851,7 +851,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	84
  VARIABLE_SCOPE	GLOBAL
@@ -143,7 +171,7 @@
  VARIABLE_COMMENT	InnoDB Fulltext search minimum token size in characters
  NUMERIC_MIN_VALUE	0
  NUMERIC_MAX_VALUE	16
-@@ -839,7 +839,7 @@
+@@ -875,7 +875,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	2000
  VARIABLE_SCOPE	GLOBAL
@@ -152,7 +180,7 @@
  VARIABLE_COMMENT	InnoDB Fulltext search number of words to optimize for each optimize table call 
  NUMERIC_MIN_VALUE	1000
  NUMERIC_MAX_VALUE	10000
-@@ -851,10 +851,10 @@
+@@ -887,10 +887,10 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	2000000000
  VARIABLE_SCOPE	GLOBAL
@@ -174,7 +202,7 @@
  VARIABLE_COMMENT	InnoDB Fulltext search parallel sort degree, will round up to nearest power of 2 number
  NUMERIC_MIN_VALUE	1
  NUMERIC_MAX_VALUE	16
-@@ -887,10 +887,10 @@
+@@ -923,10 +923,10 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	640000000
  VARIABLE_SCOPE	GLOBAL
@@ -187,7 +215,7 @@
  NUMERIC_BLOCK_SIZE	0
  ENUM_VALUE_LIST	NULL
  READ_ONLY	NO
-@@ -935,22 +935,22 @@
+@@ -971,7 +971,7 @@
  SESSION_VALUE	NULL
  DEFAULT_VALUE	200
  VARIABLE_SCOPE	GLOBAL
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/r/sysvars_innodb.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/sys_vars/r/sysvars_innodb.result
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/r/sysvars_innodb.result
@@ -5,6 +5,7 @@ variable_name not in (
 'innodb_evict_tables_on_commit_debug', # one may want to override this
 'innodb_use_native_aio',            # default value depends on OS
 'innodb_log_file_buffering',        # only available on Linux and Windows
+'innodb_buffer_pool_size_auto_min', # only available on Linux for now
 'innodb_buffer_pool_load_pages_abort')            # debug build only, and is only for testing
 order by variable_name;
 VARIABLE_NAME	INNODB_ADAPTIVE_FLUSHING
@@ -96,7 +97,7 @@ SESSION_VALUE	NULL
 DEFAULT_VALUE	0
 VARIABLE_SCOPE	GLOBAL
 VARIABLE_TYPE	BIGINT UNSIGNED
-VARIABLE_COMMENT	Size of a single memory chunk for resizing buffer pool. Online buffer pool resizing happens at this granularity. 0 means autosize this variable based on buffer pool size.
+VARIABLE_COMMENT	Deprecated parameter with no effect
 NUMERIC_MIN_VALUE	0
 NUMERIC_MAX_VALUE	18446744073709551615
 NUMERIC_BLOCK_SIZE	1048576
@@ -206,11 +207,23 @@ VARIABLE_SCOPE	GLOBAL
 VARIABLE_TYPE	BIGINT UNSIGNED
 VARIABLE_COMMENT	The size of the memory buffer InnoDB uses to cache data and indexes of its tables.
 NUMERIC_MIN_VALUE	2097152
-NUMERIC_MAX_VALUE	9223372036854775807
+NUMERIC_MAX_VALUE	18446744073701163008
 NUMERIC_BLOCK_SIZE	1048576
 ENUM_VALUE_LIST	NULL
 READ_ONLY	NO
 COMMAND_LINE_ARGUMENT	REQUIRED
+VARIABLE_NAME	INNODB_BUFFER_POOL_SIZE_MAX
+SESSION_VALUE	NULL
+DEFAULT_VALUE	0
+VARIABLE_SCOPE	GLOBAL
+VARIABLE_TYPE	BIGINT UNSIGNED
+VARIABLE_COMMENT	Maximum innodb_buffer_pool_size
+NUMERIC_MIN_VALUE	0
+NUMERIC_MAX_VALUE	18446744073701163008
+NUMERIC_BLOCK_SIZE	8388608
+ENUM_VALUE_LIST	NULL
+READ_ONLY	YES
+COMMAND_LINE_ARGUMENT	REQUIRED
 VARIABLE_NAME	INNODB_BUF_DUMP_STATUS_FREQUENCY
 SESSION_VALUE	NULL
 DEFAULT_VALUE	0
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.opt
===================================================================
--- /dev/null
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.opt
@@ -0,0 +1 @@
+--innodb-buffer-pool-size-max=8m
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.test
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.test
@@ -24,35 +24,19 @@
 
 --source include/have_innodb.inc
 
-let $wait_condition =
-  SELECT SUBSTR(variable_value, 1, 30) = 'Completed resizing buffer pool'
-  FROM information_schema.global_status
-  WHERE LOWER(variable_name) = 'innodb_buffer_pool_resize_status';
-
 SET @start_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size;
 
---echo '#---------------------BS_STVARS_022_01----------------------#'
-####################################################################
-#   Displaying default value                                       #
-####################################################################
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
---echo 1 Expected
-
-
 --echo '#---------------------BS_STVARS_022_02----------------------#'
 ####################################################################
 #   Check if Value can set                                         #
 ####################################################################
 
-SET @@GLOBAL.innodb_buffer_pool_size=10485760;
---echo Expected succeeded
---source include/wait_condition.inc
-
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
---echo 1 Expected
-
-
-
+--enable_warnings
+SELECT @@GLOBAL.innodb_buffer_pool_size_max;
+SELECT @@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max;
+SET GLOBAL innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max + 1048576;
+SELECT @@GLOBAL.innodb_buffer_pool_size = @@GLOBAL.innodb_buffer_pool_size_max;
+--disable_warnings
 
 --echo '#---------------------BS_STVARS_022_03----------------------#'
 #################################################################
@@ -66,9 +50,6 @@ WHERE VARIABLE_NAME='innodb_buffer_pool_
 --enable_warnings
 --echo 1 Expected
 
-SELECT COUNT(@@GLOBAL.innodb_buffer_pool_size);
---echo 1 Expected
-
 --disable_warnings
 SELECT COUNT(VARIABLE_VALUE)
 FROM INFORMATION_SCHEMA.GLOBAL_VARIABLES 
@@ -76,8 +57,6 @@ WHERE VARIABLE_NAME='innodb_buffer_pool_
 --enable_warnings
 --echo 1 Expected
 
-
-
 --echo '#---------------------BS_STVARS_022_04----------------------#'
 ################################################################################
 #  Check if accessing variable with and without GLOBAL point to same variable  #
@@ -111,4 +90,6 @@ SELECT innodb_buffer_pool_size = @@SESSI
 
 
 # Restore the original buffer pool size.
---source include/restart_mysqld.inc
+SET GLOBAL innodb_buffer_pool_size = @start_buffer_pool_size;
+
+SELECT @@innodb_buffer_pool_size = @start_buffer_pool_size;
Index: mariadb-10.11.11/mysql-test/suite/sys_vars/t/sysvars_innodb.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/sys_vars/t/sysvars_innodb.test
+++ mariadb-10.11.11/mysql-test/suite/sys_vars/t/sysvars_innodb.test
@@ -12,5 +12,6 @@ select VARIABLE_NAME, SESSION_VALUE, DEF
     'innodb_evict_tables_on_commit_debug', # one may want to override this
     'innodb_use_native_aio',            # default value depends on OS
     'innodb_log_file_buffering',        # only available on Linux and Windows
+    'innodb_buffer_pool_size_auto_min', # only available on Linux for now
     'innodb_buffer_pool_load_pages_abort')            # debug build only, and is only for testing
   order by variable_name;
Index: mariadb-10.11.11/mysys/CMakeLists.txt
===================================================================
--- mariadb-10.11.11.orig/mysys/CMakeLists.txt
+++ mariadb-10.11.11/mysys/CMakeLists.txt
@@ -46,7 +46,8 @@ SET(MYSYS_SOURCES  array.c charset-def.c
                                 my_uuid.c wqueue.c waiting_threads.c ma_dyncol.c ../sql-common/my_time.c
 				my_rdtsc.c psi_noop.c
                                 my_atomic_writes.c my_cpu.c my_likely.c my_largepage.c
-                                file_logger.c my_dlerror.c   crc32/crc32c.cc)
+                                file_logger.c my_dlerror.c   crc32/crc32c.cc
+                                my_virtual_mem.c)
 
 IF (WIN32)
   SET (MYSYS_SOURCES ${MYSYS_SOURCES}
